/*	$OpenBSD: sbrk.S,v 1.7 2015/09/05 06:22:47 guenther Exp $	*/
/*	$NetBSD: sbrk.S,v 1.1 2001/06/19 00:25:06 fvdl Exp $	*/

/*-
 * Copyright (c) 1990 The Regents of the University of California.
 * All rights reserved.
 *
 * This code is derived from software contributed to Berkeley by
 * William Jolitz.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	from: @(#)sbrk.s	5.1 (Berkeley) 4/23/90
 */

#include <machine/asm.h>

#include "SYS.h"

	.globl	_end
	.globl	__curbrk
	.hidden	__curbrk

	.data
__curbrk:	.quad	_end
	END(__curbrk)
	.type	__curbrk,@object
	.text

	.weak	sbrk
ENTRY(sbrk)
#ifdef __PIC__
	movq	PIC_GOT(__curbrk),%rdx
	movslq  %edi, %rax
	movq	(%rdx),%rdi
	addq	%rax,%rdi
	SYSTRAP(break)
	jc	1f
	movq	PIC_GOT(__curbrk),%rdx
	movq	(%rdx),%rax
	movq	%rdi,(%rdx)
	ret
1:
	mov	PIC_GOT(CERROR),%rdx
	jmp	*%rdx
#else
	movq	__curbrk(%rip),%rax
	movslq	%edi,%rsi
	movq	%rsi,%rdi
	addq	%rax,%rdi
	SYSTRAP(break)
	jc	1f
	movq	__curbrk(%rip),%rax
	addq	%rsi,__curbrk(%rip)
	ret
1:
	jmp	CERROR
#endif
END(sbrk)
